//---------------------------------------------------------------------------
#ifndef RsMatrixCH
#define RsMatrixCH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

//---------------------------------------------------------------------------
class PACKAGE TRsMatrixC : public TComponent
{
private:
    TNotifyEvent FOnProductError;
    TNotifyEvent FOnDifferenceError;
    TNotifyEvent FOnSumError;
    TNotifyEvent FOnTraceOfError;
    TNotifyEvent FOnTransposeError;
    long __fastcall GetRows(Variant v);
    long __fastcall GetCols(Variant v);
   

protected:
public:
    __fastcall TRsMatrixC(TComponent* Owner);
     void  Product( const double **m1 , long  rows1 ,long cols1 , const double **m2 , long rows2 , long  cols2 , double ***m3, long *rows3 , long *cols3);
     void __fastcall Sum( const double **m1 , long  rows1 ,long cols1 ,  const double **m2 , long  rows2 , long cols2 ,  double ***m3 );
     void __fastcall Difference( const double **m1 , long  rows1 ,long cols1 , const double **m2 , long  rows2 , long cols2 , double ***m3 );
     double __fastcall TraceOf(const double **m1 , long rows , long cols );
     void __fastcall Transpose( const double **m1 , long rows , long cols , double ***transposed);
__published:
    __property TNotifyEvent OnProductError  = { read = FOnProductError, write = FOnProductError };
    __property TNotifyEvent OnDifferenceError  = { read = FOnDifferenceError, write = FOnDifferenceError };
    __property TNotifyEvent OnSumError  = { read = FOnSumError, write = FOnSumError };
    __property TNotifyEvent OnTraceOfError  = { read = FOnTraceOfError, write = FOnTraceOfError };
    __property TNotifyEvent OnTransposeError  = { read = FOnTransposeError, write = FOnTransposeError };
};
//---------------------------------------------------------------------------
#endif
